// CodeGear C++Builder
// Copyright (c) 1995, 2010 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'LogFile.pas' rev: 22.00

#ifndef LogfileHPP
#define LogfileHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <LogBase.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Logfile
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS EFileNotificationError;
class PASCALIMPLEMENTATION EFileNotificationError : public Sysutils::Exception
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ inline __fastcall EFileNotificationError(const System::UnicodeString Msg) : Sysutils::Exception(Msg) { }
	/* Exception.CreateFmt */ inline __fastcall EFileNotificationError(const System::UnicodeString Msg, System::TVarRec const *Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ inline __fastcall EFileNotificationError(int Ident)/* overload */ : Sysutils::Exception(Ident) { }
	/* Exception.CreateResFmt */ inline __fastcall EFileNotificationError(int Ident, System::TVarRec const *Args, const int Args_Size)/* overload */ : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ inline __fastcall EFileNotificationError(const System::UnicodeString Msg, int AHelpContext) : Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ inline __fastcall EFileNotificationError(const System::UnicodeString Msg, System::TVarRec const *Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext) { }
	/* Exception.CreateResHelp */ inline __fastcall EFileNotificationError(int Ident, int AHelpContext)/* overload */ : Sysutils::Exception(Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ inline __fastcall EFileNotificationError(System::PResStringRec ResStringRec, System::TVarRec const *Args, const int Args_Size, int AHelpContext)/* overload */ : Sysutils::Exception(ResStringRec, Args, Args_Size, AHelpContext) { }
	/* Exception.Destroy */ inline __fastcall virtual ~EFileNotificationError(void) { }
	
};


#pragma option push -b-
enum TFileNotificationOption { foFile, foFolder, foAttributes, foSize, foTime, foWatchSubFolders };
#pragma option pop

typedef System::Set<TFileNotificationOption, TFileNotificationOption::foFile, TFileNotificationOption::foWatchSubFolders>  TFileNotificationOptions;

typedef void __fastcall (__closure *TFileNotifyEvent)(System::TObject* Sender, TFileNotificationOption Action);

class DELPHICLASS TNotificationThread;
class DELPHICLASS TSMFileLog;
class PASCALIMPLEMENTATION TNotificationThread : public Classes::TThread
{
	typedef Classes::TThread inherited;
	
private:
	TSMFileLog* FOwner;
	System::StaticArray<unsigned, 8> FHandles;
	System::StaticArray<TFileNotificationOption, 8> FHandleFilters;
	int FHandleCount;
	TFileNotificationOption FActiveFilter;
	void __fastcall ReleaseHandles(void);
	void __fastcall AllocateHandles(void);
	
protected:
	virtual void __fastcall Execute(void);
	void __fastcall Notify(void);
	
public:
	__fastcall TNotificationThread(TSMFileLog* Owner);
	__fastcall virtual ~TNotificationThread(void);
	void __fastcall Reset(void);
};


class PASCALIMPLEMENTATION TSMFileLog : public Logbase::TSMLogBase
{
	typedef Logbase::TSMLogBase inherited;
	
private:
	TNotificationThread* FThread;
	System::UnicodeString FFolder;
	TFileNotificationOptions FOptions;
	TFileNotifyEvent FOnFileNotification;
	void __fastcall SetOptions(TFileNotificationOptions Value);
	void __fastcall SetFolder(System::UnicodeString Value);
	
protected:
	virtual void __fastcall Notify(TFileNotificationOption Action);
	virtual void __fastcall Loaded(void);
	virtual void __fastcall SetActive(bool Value);
	
public:
	__fastcall virtual TSMFileLog(Classes::TComponent* AOwner);
	__fastcall virtual ~TSMFileLog(void);
	
__published:
	__property System::UnicodeString Folder = {read=FFolder, write=SetFolder};
	__property TFileNotificationOptions Options = {read=FOptions, write=SetOptions, nodefault};
	__property TFileNotifyEvent OnFileNotification = {read=FOnFileNotification, write=FOnFileNotification};
};


//-- var, const, procedure ---------------------------------------------------
extern "C" unsigned __stdcall FindFirstChangeNotification(System::WideChar * lpPathName, unsigned bWatchSubtree, unsigned dwNotifyFilter);

}	/* namespace Logfile */
#if !defined(DELPHIHEADER_NO_IMPLICIT_NAMESPACE_USE)
using namespace Logfile;
#endif
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// LogfileHPP
